#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "memory.h"
#include <QSize>
#include <QTimer>
#include "qcardbutton.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	explicit MainWindow(QWidget *parent = 0);
	~MainWindow();

	void refreshMemoryCards();

	static unsigned s_maxNbOfPairs;
	static unsigned s_hideCardsTimeout;
	static QSize	s_cardFixedSize;

private:
	Ui::MainWindow *ui;
	Memory m_memory;

	QSize _unsignedToQSize(unsigned index);
	unsigned _QSizeToUnsigned(QSize size);
	unsigned _GetNbColumnsLayout();

	std::vector<CardButton*> m_cardButtons;

	CardButton *m_selectedCards[2];

	QTimer *m_timerHideCards;

private slots:

	void on_cardButton_pushed();
	void on_timerHideCards_timeout();
	void on_pushButton_play_pressed();
	void on_pushButton_reset_pressed();
};

void clearLayout(QLayout *layout);

#endif // MAINWINDOW_H
